::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: EATON
:: L.Lefebvre 28-12-2016
:: 
:: this script adds the RNDIS IP address 169.254.* of the card 
:: into the proxy exceptions list (only if proxy is enabled)
:: (Windows only) 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

@echo off
:: set your exception string here
SET rndisExcept=169.254.*

:: test if proxy is enabled
:: warning: delims is a TAB followed by a space

FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v ProxyEnable') DO SET proxyStatus=%%B
::ECHO proxyStatus=%proxyStatus%

:: if proxy is enabled then add card's RNDIS IP address in proxy exception list
if /I "%proxyStatus%" EQU "0x1" GOTO proxyEnabledLabel

ECHO proxy is disabled, so no need to add any exception
GOTO endLabel

:proxyEnabledLabel
ECHO proxy is enabled

:: first retrieve proxy server and exceptions list from registry
FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v ProxyServer') DO SET proxyServer=%%B
::ECHO proxyServer=%proxyServer%

FOR /F "tokens=2* delims=	 " %%A IN ('REG QUERY "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v ProxyOverride') DO SET proxyOverride=%%B
::ECHO proxyOverride="%proxyOverride%"

:: search for RNDIS exception
ECHO  "%proxyOverride%" | find "%rndisExcept%" > NUL
::ECHO %ERRORLEVEL%
if %ERRORLEVEL% NEQ 0 goto rndisExceptNotfound

ECHO RNDIS exception is already present in proxy settings, nothing to do
GOTO endLabel

:rndisExceptNotfound
:: add card RNDIS address in (APIPA range)
::SET proxyOverride="%proxyOverride%;%rndisExcept%"
SET proxyOverride="%rndisExcept%;%proxyOverride%"
::ECHO proxyOverride=%proxyOverride%

:: use netsh to set proxy settings instead of registry set (allows to remove settings with "netsh winhttp reset proxy" command)
:: discarded because does not update registry
:: netsh winhttp set proxy proxy-server=%proxyServer% bypass-list=%proxyOverride%

:: modify registry
reg add "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings" /v ProxyOverride /t REG_SZ /d %proxyOverride% /f
ECHO.
ECHO RNDIS "%rndisExcept%" exception has been added 
ECHO into proxy "%proxyServer%" exceptions list
ECHO Please wait for Internet Explorer launch (this will update proxy settings)
start iexplore.exe

ECHO.
:endLabel
pause
